
#pragma used+
sfrb PINF=0;
sfrb PINE=1;
sfrb DDRE=2;
sfrb PORTE=3;
sfrb ADCL=4;
sfrb ADCH=5;
sfrw ADCW=4;      
sfrb ADCSRA=6;
sfrb ADMUX=7;
sfrb ACSR=8;
sfrb UBRR0L=9;
sfrb UCSR0B=0xa;
sfrb UCSR0A=0xb;
sfrb UDR0=0xc;
sfrb SPCR=0xd;
sfrb SPSR=0xe;
sfrb SPDR=0xf;
sfrb PIND=0x10;
sfrb DDRD=0x11;
sfrb PORTD=0x12;
sfrb PINC=0x13;
sfrb DDRC=0x14;
sfrb PORTC=0x15;
sfrb PINB=0x16;
sfrb DDRB=0x17;
sfrb PORTB=0x18;
sfrb PINA=0x19;
sfrb DDRA=0x1a;
sfrb PORTA=0x1b;
sfrb EECR=0x1c;
sfrb EEDR=0x1d;
sfrb EEARL=0x1e;
sfrb EEARH=0x1f;
sfrw EEAR=0x1e;   
sfrb SFIOR=0x20;
sfrb WDTCR=0x21;
sfrb OCDR=0x22;
sfrb OCR2=0x23;
sfrb TCNT2=0x24;
sfrb TCCR2=0x25;
sfrb ICR1L=0x26;
sfrb ICR1H=0x27;
sfrw ICR1=0x26;   
sfrb OCR1BL=0x28;
sfrb OCR1BH=0x29;
sfrw OCR1B=0x28;  
sfrb OCR1AL=0x2a;
sfrb OCR1AH=0x2b;
sfrw OCR1A=0x2a;  
sfrb TCNT1L=0x2c;
sfrb TCNT1H=0x2d;
sfrw TCNT1=0x2c;  
sfrb TCCR1B=0x2e;
sfrb TCCR1A=0x2f;
sfrb ASSR=0x30;
sfrb OCR0=0x31;
sfrb TCNT0=0x32;
sfrb TCCR0=0x33;
sfrb MCUCSR=0x34;
sfrb MCUCR=0x35;
sfrb TIFR=0x36;
sfrb TIMSK=0x37;
sfrb EIFR=0x38;
sfrb EIMSK=0x39;
sfrb EICRB=0x3a;
sfrb XDIV=0x3c;
sfrb SPL=0x3d;
sfrb SPH=0x3e;
sfrb SREG=0x3f;
#pragma used-

#asm
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x20
	.EQU __sm_mask=0x1C
	.EQU __sm_powerdown=0x10
	.EQU __sm_powersave=0x18
	.EQU __sm_standby=0x14
	.EQU __sm_ext_standby=0x1C
	.EQU __sm_adc_noise_red=0x08
	.SET power_ctrl_reg=mcucr
	#endif
#endasm

#asm
   .equ __lcd_port=0x12 ;PORTD
#endasm

#pragma used+

void _lcd_ready(void);
void _lcd_write_data(unsigned char data);

void lcd_write_byte(unsigned char addr, unsigned char data);

unsigned char lcd_read_byte(unsigned char addr);

void lcd_gotoxy(unsigned char x, unsigned char y);

void lcd_clear(void);
void lcd_putchar(char c);

void lcd_puts(char *str);

void lcd_putsf(char flash *str);

unsigned char lcd_init(unsigned char lcd_columns);

#pragma used-
#pragma library lcd.lib

typedef char *va_list;

#pragma used+

char getchar(void);
void putchar(char c);
void puts(char *str);
void putsf(char flash *str);

char *gets(char *str,unsigned int len);

void printf(char flash *fmtstr,...);
void sprintf(char *str, char flash *fmtstr,...);
void snprintf(char *str, unsigned int size, char flash *fmtstr,...);
void vprintf (char flash * fmtstr, va_list argptr);
void vsprintf (char *str, char flash * fmtstr, va_list argptr);
void vsnprintf (char *str, unsigned int size, char flash * fmtstr, va_list argptr);
signed char scanf(char flash *fmtstr,...);
signed char sscanf(char *str, char flash *fmtstr,...);

#pragma used-

#pragma library stdio.lib

char lcd_buffer[33];
int angle_a,angle_b=120,angle_c=240,u_a,w_a,u_b,w_b,u_c,w_c;
unsigned char table[91]={  2, 3, 5, 7, 9, 10,12,14,16,17,
19,20,22,24,26,28,29,31,33,34,
36,37,39,40,42,44,45,47,48,50,
52,53,54,56,57,59,60,62,63,64,
66,67,68,69,71,72,73,74,75,76,
77,79,80,81,82,83,84,85,86,87,
87,88,89,90,91,91,92,93,93,94,
95,95,96,96,97,97,97,98,98,98,
99,99,99,99,99,99,99,99,99,100,100};
unsigned char f,cnt,cntt,fr=6,i;                           

interrupt [16] void timer0_comp_isr(void)
{

if(angle_a==360)angle_a=0;
if(angle_b==360)angle_b=0;
if(angle_c==360)angle_c=0;
if(cntt==18)
{
PORTB.0=~PORTB.0;
cntt=0;
}
cntt++;
angle_a++;
angle_b++;
angle_c++;
if(u_a<5)u_a=255;
OCR1AL=u_a;
if(w_a<5)w_a=255;
(*(unsigned char *) 0x86)=w_a;
if(u_b<5)u_b=255;
OCR1BL=u_b;
if(w_b<5)w_b=255;
(*(unsigned char *) 0x84)=w_b;
if(u_c<5)u_c=255;
(*(unsigned char *) 0x78)=u_c;
if(w_c<5)w_c=255;
(*(unsigned char *) 0x78)=w_c;
}

interrupt [15] void timer1_ovf_isr(void)
{

}

interrupt [11] void timer2_ovf_isr(void)
{

if(cnt==5)
{
cnt=0;
if(fr<50 && PINB.1==0)fr++;
if(fr>6 && PINB.2==0)fr--;
f=(1389/fr)-1;
OCR0=f;
}

cnt++;

}

interrupt [30] void timer3_ovf_isr(void)
{

}

void main(void)
{

PORTA=0x00;
DDRA=0x00;

PORTB=0x0E;
DDRB=0xF1;

PORTC=0x00;
DDRC=0x00;

PORTD=0x00;
DDRD=0x00;

PORTE=0x00;
DDRE=0x38;

(*(unsigned char *) 0x62)=0x00;
(*(unsigned char *) 0x61)=0x00;

(*(unsigned char *) 0x65)=0x00;
(*(unsigned char *) 0x64)=0x00;

ASSR=0x00;
TCCR0=0x0B;
TCNT0=0x00;
OCR0=0x00;

TCCR1A=0xA9;
TCCR1B=0x02;
TCNT1H=0x00;
TCNT1L=0x00;
ICR1H=0x00;
ICR1L=0x00;
OCR1AH=0x00;
OCR1AL=0x00;
OCR1BH=0x00;
OCR1BL=0x00;
(*(unsigned char *) 0x79)=0x00;
(*(unsigned char *) 0x78)=0x00;

TCCR2=0x05;
TCNT2=0x00;
OCR2=0x00;

(*(unsigned char *) 0x8b)=0xA9;
(*(unsigned char *) 0x8a)=0x02;
(*(unsigned char *) 0x89)=0x00;
(*(unsigned char *) 0x88)=0x00;
(*(unsigned char *) 0x81)=0x00;
(*(unsigned char *) 0x80)=0x00;
(*(unsigned char *) 0x87)=0x00;
(*(unsigned char *) 0x86)=0x00;
(*(unsigned char *) 0x85)=0x00;
(*(unsigned char *) 0x84)=127;
(*(unsigned char *) 0x83)=0x00;
(*(unsigned char *) 0x82)=0x00;

(*(unsigned char *) 0x6a)=0x00;
EICRB=0x00;
EIMSK=0x00;

TIMSK=0x46;
(*(unsigned char *) 0x7d)=0x04;

ACSR=0x80;
SFIOR=0x00;
lcd_init(16);

#asm("sei")

while (1)
{
lcd_gotoxy(0,0);
sprintf(lcd_buffer,"fr=%u   ",fr);
lcd_puts(lcd_buffer); 

if(angle_a>0 && angle_a<=90) i=angle_a;
if(angle_a>90 && angle_a<=180) i=90-(angle_a-90);
if(angle_a>180 && angle_a<=270) i=angle_a-180;
if(angle_a>270 && angle_a<=360) i=90-(angle_a-270);
if(angle_a<180) 
{
u_a=(table[i]*5*fr)/100;
w_a=255;
}
if(angle_a>180)
{
u_a=255;
w_a=(table[i]*5*fr)/100;
}
if(angle_b>0 && angle_b<=90) i=angle_b;
if(angle_b>90 && angle_b<=180) i=90-(angle_b-90);
if(angle_b>180 && angle_b<=270) i=angle_b-180;
if(angle_b>270 && angle_b<=360) i=90-(angle_b-270);
if(angle_b<180) 
{
u_b=(table[i]*5*fr)/100;
w_b=255;
}
if(angle_b>180)
{
u_b=255;
w_b=(table[i]*5*fr)/100;
}
if(angle_c>0 && angle_c<=90) i=angle_c;
if(angle_c>90 && angle_c<=180) i=90-(angle_c-90);
if(angle_c>180 && angle_c<=270) i=angle_c-180;
if(angle_c>270 && angle_c<=360) i=90-(angle_c-270);
if(angle_c<180) 
{
u_c=(table[i]*5*fr)/100;
w_c=255;
}
if(angle_c>180)
{
u_c=255;
w_c=(table[i]*5*fr)/100;
}

};
}
